VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsUserDatabase"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private DatabasePath As String
Private Users() As New clsDatabase

Public Function Count() As Integer
On Error Resume Next
    Count = UBound(Users)
End Function

Public Function GetUsers() As clsDatabase()
    GetUsers = Users
End Function
Public Function Safelist(Username As String) As Boolean
    Safelist = GetByName(Username).Safelisted
End Function
Public Function Friended(Username As String) As Boolean
    Friended = GetByName(Username).Friended
End Function
Public Function Autobanned(Username As String) As Boolean
    Autobanned = GetByName(Username).Autobanned
End Function
Public Function Autodesignated(Username As String) As Boolean
    Autodesignated = GetByName(Username).Autodesignated
End Function
Public Function GetByIndex(Index As Integer) As clsDatabase
On Error GoTo hErr:
    Set GetByIndex = Users(Index)
    Exit Function
hErr:
    Set GetByIndex = New clsDatabase
End Function

Public Function GetByName(Username As String) As clsDatabase

    Dim I As Integer
    I = Find(Username)
    If I > -1 Then
        Set GetByName = Users(I)
        Exit Function
    End If
    Set GetByName = New clsDatabase

End Function
Public Sub SetUser(Index As Integer, User As clsDatabase)
    Set Users(Index) = User
End Sub

Private Function Same(Str1 As String, Str2 As String) As Boolean
    Same = LCase$(Str1) = LCase$(Str2)
End Function

Public Sub Clear()
    ReDim Users(0)
End Sub

Public Sub Load(P As String)
    DatabasePath = P
    ReDim Users(0)
    Dim FF As Integer, Content As String, Line As Long
    FF = FreeFile
    Open DatabasePath For Append As #FF
    Close #FF
    Open DatabasePath For Input As #FF
        Do Until EOF(FF) Or Err
            Line Input #FF, Content
            Line = Line + 1
            If InStrB(Content, "%") <> 0 Then
                Dim Data() As String, Out As String
                Data = Split(Content, "%")
                If UBound(Data) = 6 Then
                    If Not Add(Data(0), Data(1), Data(2), Data(3), Data(4), Data(5), Data(6), False) Then
                        Debug.Print "Cannot add user at line: " & Line & " -- " & Out
                    End If
                Else
                    Debug.Print "Invalid user at line: " & Line
                End If
            End If
        Loop
    Close #FF
    Save
End Sub

Public Sub Save()
    Dim FF As Integer: FF = FreeFile
    Open DatabasePath For Append As #FF
    Close #FF
    Open DatabasePath For Output As #FF
        Dim I As Integer
        For I = 0 To UBound(Users)
            Print #FF, Users(I).Username & "%" & Users(I).AttributeString & "%" & Users(I).Group & "%" & Users(I).AddedTime & "%" & Users(I).AddedDate & "%" & Users(I).Addedby & "%" & Users(I).ModifiedBy
        Next I
    Close #FF
End Sub

Public Function Add(User As String, Attributes As String, _
    Optional Group As String, Optional AddTime As String, Optional AddDate As String, Optional AddBy As String, Optional ModifiedBy As String, Optional DoSave As Boolean = True, Optional UserFlags As Long = ATTR_A) As Boolean
    
    If Find(User) > -1 Then: Exit Function
    If LenB(AddTime) = 0 Then AddTime = Time
    If LenB(AddDate) = 0 Then AddDate = Date
    If LenB(AddBy) = 0 Then AddBy = "[Knight]"
    If LenB(Group) = 0 Then Group = vbNullString
    If LenB(ModifiedBy) = 0 Then ModifiedBy = vbNullString
    
    If (CanAdd(UserFlags, StringToAttribute(Attributes) Or Groups.GetByName(Group).Attributes) = False) Then
        Add = False
        Exit Function
    End If
    
    Dim IU As New clsDatabase
    With IU
        .Attributes = StringToAttribute(Attributes)
        .Group = Group
        .Addedby = AddBy
        .AddedDate = AddDate
        .AddedTime = AddTime
        .Username = User
        .ModifiedBy = ModifiedBy
    End With
    
    If LenB(Users(0).Username) = 0 Then
        Set Users(0) = IU
    Else
        ReDim Preserve Users(UBound(Users) + 1)
        Set Users(UBound(Users)) = IU
    End If
    
    Add = True
    If DoSave Then Save
End Function
Public Function CanAdd(UserFlags As Long, FlagsToAdd As Long, Optional ModifyUsersFlags As Long) As Boolean
        
        If (ATTR_A And UserFlags) = ATTR_A Then GoTo PassCheck

        If ((ATTR_D And UserFlags) = ATTR_D) Or ((ATTR_O And UserFlags) = ATTR_O) Then
            If (ATTR_L And ModifyUsersFlags) = ATTR_L Then GoTo FailCheck
            If (ATTR_A And ModifyUsersFlags) = ATTR_A Then GoTo FailCheck
            If (ATTR_A And FlagsToAdd) = ATTR_A Then GoTo FailCheck
            If (ATTR_C And FlagsToAdd) = ATTR_C Then GoTo FailCheck
            If (ATTR_D And FlagsToAdd) = ATTR_D Then GoTo FailCheck
            If (ATTR_E And FlagsToAdd) = ATTR_E Then GoTo FailCheck
            If (ATTR_L And FlagsToAdd) = ATTR_L Then GoTo FailCheck
            If (ATTR_N And FlagsToAdd) = ATTR_N Then GoTo FailCheck
            If (ATTR_X And FlagsToAdd) = ATTR_X Then GoTo FailCheck
            If (ATTR_Z And FlagsToAdd) = ATTR_Z Then GoTo FailCheck
        End If
        
        If ((ATTR_D And UserFlags) = ATTR_D) Then GoTo PassCheck
        
        If ((ATTR_O And UserFlags) = ATTR_O) Then
            If (ATTR_S And ModifyUsersFlags) = ATTR_S Then GoTo FailCheck
            'If (ATTR_B And FlagsToAdd) = ATTR_B Then GoTo FailCheck
            If (ATTR_J And FlagsToAdd) = ATTR_J Then GoTo FailCheck
            If (ATTR_O And FlagsToAdd) = ATTR_O Then GoTo FailCheck
            If (ATTR_S And FlagsToAdd) = ATTR_S Then GoTo FailCheck
        End If
             
PassCheck:
        CanAdd = True
        Exit Function
FailCheck:
        CanAdd = False
        Exit Function
End Function
Public Function Update(User As clsDatabase, Operation As String, UserToModify As Integer, Data As String) As Boolean
        Dim I As Integer, Attributes As Long, Group As String
        Attributes = StringToAttribute(Data)

        If Operation = "'" Then
            If (CanAdd(User.Flags, _
            Attributes Or Groups.GetByName(Data).Attributes, _
            Users(UserToModify).Flags) = False) Then
                Update = False
                Exit Function
            End If
            
            Users(UserToModify).Group = Data
            
        Else
            If (CanAdd(User.Flags, _
            Attributes Or Groups.GetByName(Data).Attributes, _
            Users(UserToModify).Flags) = False) Then
                Update = False
                Exit Function
            End If
    
            Users(UserToModify).Attributes = Users(UserToModify).Attributes Xor Attributes
        
        End If
        
        Users(UserToModify).ModifiedBy = User.Username
        Users(UserToModify).AddedDate = Date
        Users(UserToModify).AddedTime = Time
        
        Update = True
        Save
End Function
Public Function findPattern(ByVal User As String) As Integer
    If LenB(User) = 0 Then findPattern = -2: Exit Function
    Dim I As Integer
    User = LCase$(User)
    For I = UBound(Users) To 0 Step -1
        If User = LCase$(Users(I).Username) Then
            findPattern = I
            Exit Function
        End If
    Next I
    findPattern = -1
End Function

Public Function Find(ByVal User As String) As Integer
    'User = Replace(User, ",", vbNullString)
    'User = Replace(User, Chr(34), vbNullString)
    'If Warcraft3 = False Then User = Replace(LCase$(User), "@uswest", vbNullString)
   ' If Warcraft3 = False Then User = Replace(LCase$(User), "@useast", vbNullString)
    'If Warcraft3 = True Then User = Replace(LCase$(User), "@azeroth", vbNullString)
    'If Warcraft3 = True Then User = Replace(LCase$(User), "@lordaeron", vbNullString)
    
    If LenB(User) = 0 Then Find = -2: Exit Function
    Dim I As Integer
    User = LCase$(User)
    For I = UBound(Users) To 0 Step -1
        If User = LCase$(Users(I).Username) Then
            Find = I
            Exit Function
        End If
    Next I
   ' For i = UBound(Users) To 0 Step -1
    '    If Matches(User, LCase$(Users(i).Username)) Then
    '        If GetRankByID(Users(i).RankID).PatternMatch Then Find = i
    '        Exit Function
    '    End If
    'Next i
    Find = -1
End Function

Public Function matchUser(ByVal Match As String, ByRef Result() As Integer) As Boolean
    If LenB(Match) = 0 Then matchUser = False: Exit Function
    Dim I() As Integer, X As Integer
    ReDim I(0): I(0) = -1
    For X = UBound(Users) To 0 Step -1
        If Matches(Users(X).Username, Match) Then
            If I(0) = -1 Then
                I(0) = X
            Else
                ReDim Preserve I(UBound(I) + 1)
                I(UBound(I)) = X
            End If
        End If
    Next X
    If I(0) <> -1 Then matchUser = True
    Result = I
End Function

Public Function Remove(ByVal User As String) As Boolean
    Dim I As Integer, R As Integer
    User = LCase$(User)
    If UBound(Users) = 0 Then
        If LCase$(Users(0).Username) = User Then
            ReDim Users(0)
            Remove = True
            Save
            Exit Function
        End If
    End If
    For I = 0 To UBound(Users)
        If User = LCase$(Users(I).Username) Then
            For R = I To UBound(Users) - 1
                Set Users(R) = Users(R + 1)
            Next R
            ReDim Preserve Users(UBound(Users) - 1)
            Remove = True
            Save
            Exit Function
        End If
    Next I
    Exit Function
End Function
Private Sub Class_Initialize()
    ReDim Users(0) As New clsDatabase
End Sub

Private Sub Class_Terminate()
    ReDim Users(0)
End Sub

