Attribute VB_Name = "modBNCSEvents"
Option Explicit

Public Sub Event_ShowUsers(Username As String, Ping As Long, Flags As Long, Statstring As String)
    Dim DBUser As clsDatabase, Index As Integer, User As New clsUserInfo
    Index = Database.Find(Username)
    User.Username = Username
    User.Statstring = Statstring
    User.Flags = Flags
    User.Ping = Ping
    User.TickTalk = GetTickCount()
    User.TickJoin = GetTickCount()
    Users.Insert User
    
    CheckIgnored Username
    If User.IsIgnored And IPBan Then AddQ "/ban " & Username & " ipban": Exit Sub
    
    If (Index <> -1) Then
        Set DBUser = Database.GetByIndex(Index)
        
        If (DBUser.Autodesignated) And Not User.IsOperator Then
            If OpTried = False Then
                AddQ ("/designate " & Username)
                AddQ "/resign"
                OpTried = True
                Exit Sub
            End If
        End If
        
        If User.Ping >= PingbanLimit Then
            AddQ ("/ban " & Username & " excessive ping")
            Exit Sub
        End If
        
        If DBUser.Zapped Then
            AddQ ("/ban " & Username & " zapped")
            Exit Sub
        End If
        If (DBUser.Autobanned) Then
            AddQ ("/ban " & Username & " autobanned")
            Exit Sub
        Else
            If Wildcardcheck(Username) Then AddQ ("/ban " & Username & " autobanned"): Exit Sub
        End If
    Else
        If Wildcardcheck(Username) Then AddQ ("/ban " & Username & " autobanned"): Exit Sub
    End If

    InitProtection True, Username
End Sub
Public Sub Event_Channel(Channel As String, Flags As Long)
    Banlist.Clear
    Users.Clear
    AddChat vbAwesomeOrange, "You have joined channel: " & Channel & " (0x000000" & Flags & ")"
    CurrentChannel = Channel
End Sub
Public Sub Event_UserFlags(Username As String, Ping As Long, Flags As Long)
Dim User As clsUserInfo, Index As Integer
    Index = Users.Find(Username)
    If Index <> -1 Then
        Set User = Users.GetByIndex(Index)
        User.Flags = Flags
        User.Ping = Ping
        Call CheckIgnored(Username)
        If User.IsIgnored And IPBan Then AddQ "/ban " & Username & " ipban": Exit Sub
    End If

End Sub
Public Sub Event_Talk(Username As String, Message As String, Ping As Long)
Dim I As Integer, Splt() As String, Count As String
Dim User As clsDatabase, s_Username As clsUserInfo

On Error Resume Next

    Set User = Database.GetByName(Username)
    Set s_Username = Users.GetByName(Username)
    
    If Config.FastJoin Then
        If (GetTickCount - Users.GetByName(Username).TickJoin) <= Config.FastJoinTime Then
            AddQ "/ban " & Username & " fast talk"
            Exit Sub
        End If
    End If
    
    If Spamban Then
        With s_Username
            If (GetTickCount - .TickTalk) <= 2500 Then
                .TalkCount = .TalkCount + 1
            Else
                .TalkCount = 0
            End If
            
            .TickTalk = GetTickCount()
    
            If .TalkCount = 3 Then
                AddQ "/ban " & Username & " spamban"
            End If
        End With
    End If
    
    If LCase(Message) = "?trigger" Then
        If (User.Flags <> 0 And (ATTR_I And User.Flags) = ATTR_I) Then
            SendMessage "My trigger is set to: " & Trigger, User.Username, Whisperback, False
            GoTo AllowChat
        End If
    End If
    
    If (Left$(Message, Len(Trigger)) = Trigger) Then
        If (User.Flags <> 0 And User.Flags <> ATTR_B And User.Flags <> ATTR_Z) Then
            If InStr(Message, "; ") Then
                Splt = Split(Message, "; ")
                Splt(0) = Mid$(Splt(0), Len(Trigger) + 1)
                For I = 0 To UBound(Splt)
                   If LenB(Splt(I)) <> 0 Then Call HandleCommands(Splt(I), User, Ping, False, Whisperback)
                Next I
            Else
                Call HandleCommands(Mid$(Message, Len(Trigger) + 1), User, Ping, False, Whisperback)
            End If
            GoTo AllowChat
        End If
    End If
    
Exit Sub
AllowChat:
    AddChat vbGreen, Username, vbWhite, ": " & Message
    
End Sub
Public Sub Event_Join(Username As String, Ping As Long, Flags As Long, Statstring As String)
    Dim DBUser As clsDatabase, Index As Integer, User As New clsUserInfo
    Index = Database.Find(Username)
    User.Username = Username
    User.Statstring = Statstring
    User.Flags = Flags
    User.Ping = Ping
    User.TickTalk = GetTickCount()
    User.TickJoin = GetTickCount()
    Users.Insert User
    
    Call CheckBanned(Username)
    
    If OpenChannel = True And RemoteChannel = True Then
        If LCase$(Username) = LCase$(OpenName) Then
            AddQ "/clan private"
            OpenChannel = False
            OpenName = vbNullString
            StopClanPrivateTimer
            Exit Sub
        End If
    End If
    
    Call CheckIgnored(Username)
    If User.IsIgnored Then
        If IPBan Then
            AddQ "/ban " & Username & " ipban"
            Exit Sub
        End If
    End If
    
    If User.Ping >= PingbanLimit Then
        AddQ ("/ban " & Username & " excessive ping")
        Exit Sub
    End If
        
    If (Index <> -1) Then
        
        Set DBUser = Database.GetByIndex(Index)
    
        If (DBUser.Autodesignated) And CheckOpsCount = False Then
            AddQ ("/designate " & Username)
            AddQ "/resign"
            Exit Sub
        End If
        
        If DBUser.Zapped Then
            AddQ ("/ban " & Username & " zapped")
            Exit Sub
        End If
        
        If (DBUser.Autobanned) Then
            AddQ ("/ban " & Username & " autobanned")
            Exit Sub
        Else
            If Wildcardcheck(Username) Then AddQ ("/ban " & Username & " autobanned"): Exit Sub
        End If
    Else
        If Wildcardcheck(Username) Then AddQ ("/ban " & Username & " autobanned"): Exit Sub
    End If

    InitProtection True, Username
End Sub
Public Sub Event_Leave(Username As String)
    Dim UserIndex As Integer, I As Integer
    UserIndex = Users.Find(Username)

        
    If ShortVisit = True Then
        If Users.GetByIndex(UserIndex).IsShortVisit(ShortVisitTime) Then
            AddQ ("/ban " & Username & " shortvisit")
        End If
    End If
    
    If UserIndex <> -1 Then
        If Users.GetByIndex(UserIndex).IsOperator = True Then
            OpTried = False
        End If
    End If
    
    Users.RemoveIndex UserIndex
End Sub
Public Sub Event_Whisper(Username As String, Message As String)
Dim I As Integer, Splt() As String
Dim User As New clsDatabase
    
    Set User = Database.GetByName(Username)
    
    If Sweepban = True And Message = "Sweepban!" Then
        AddQ "Sweepban has been completed!"
        Sweepban = False
    End If
    
    If LCase$(Message) = "open" And RemoteChannel = True Then
        If User.Safelisted Or User.Friended Then
            AddQ "/clan public"
            OpenChannel = True
            OpenName = Username
            OpenTimer = GetTickCount
            StartClanPrivateTimer 1000
        End If
    End If
    
    If (Left$(Message, Len(Trigger)) = Trigger) Then
        
        If (User.Flags <> 0 And User.Flags <> ATTR_B And User.Flags <> ATTR_Z) Then
            If InStr(Message, "; ") Then
                Splt = Split(Message, "; ")
                Splt(0) = Mid$(Splt(0), Len(Trigger) + 1)
                For I = 0 To UBound(Splt)
                   If LenB(Splt(I)) <> 0 Then Call HandleCommands(Splt(I), User, 0, False, Whisperback)
                Next I
            Else
                Call HandleCommands(Mid$(Message, Len(Trigger) + 1), User, 0, False, Whisperback)
            End If
        End If
    End If
    
    AddChat vbPurple, "From: " & Username & ": ", vbWhite, Message
    
    LastWhisper = Username
    countWhisper = countWhisper + 1
End Sub
Public Sub Event_WhisperSent(Username As String, Message As String)
    AddChat vbPurple, "To: " & Username & ": ", vbWhite, Message
End Sub
Public Sub Event_Emote(Username As String, Message As String)
    If Users.Find(Username) = -1 Then Exit Sub
    
    Users.GetByName(Username).TickTalk = GetTickCount()
    'AddChat vbAwesomeOrange, "*** " & Username & Space(1) & Message
End Sub
Public Sub Event_Info(Message As String)
    Dim Splt() As String
    
    AddChat vbYellow, Message
    
    If InStrB(Message, "was banned by") <> 0 Then
        Splt = Split(Message, Space$(1))
        Banlist.Add Suffix(Splt(0))
        countBanned = countBanned + 1
    ElseIf InStrB(Message, "was unbanned by") <> 0 Then
        Splt = Split(Message, Space$(1))
        Banlist.Remove Suffix(Splt(0))
        If IPBan Then AddQ "/unignore " & Suffix(Splt(0))
        countUnbanned = countUnbanned + 1
    End If

                   
    If Not Matches(Message, "Users in channel*") And Sweepban = True Then
        If InStrB(Message, ", ") <> 0 Then
            Splt = Split(Message, ", ")
            If Left$(Splt(0), 1) = "[" And Mid$(Splt(0), Len(Splt(0))) = "]" Then
                Splt(0) = Mid$(Splt(0), 2)
                Splt(0) = Left(Splt(0), Len(Splt(0)) - 1)
            End If
            If Left$(Splt(1), 1) = "[" And Mid$(Splt(1), Len(Splt(1))) = "]" Then
                Splt(1) = Mid$(Splt(1), 2)
                Splt(1) = Left(Splt(1), Len(Splt(1)) - 1)
            End If
            
            AddQ "/ban " & Splt(0) & " sweep"
            AddQ "/ban " & Splt(1) & " sweep"
        Else
            If Left$(Message, 1) = "[" And Mid$(Message, Len(Message)) = "]" Then
                Message = Mid$(Message, 2)
                Message = Left(Message, Len(Message) - 1)
            End If
            
            AddQ "/ban " & Message & " sweep"
        End If
    End If
End Sub
Public Sub Event_Error(Message As String)
    AddChat vbRed, Message
End Sub
Public Sub Event_Broadcast(Message As String)
    AddChat vbCyan, Message
End Sub

