Attribute VB_Name = "modBNCSPackets"
Option Explicit

Public Sub SendBNCS0x3D(Data As String)

    With PBuffer
        .InsertNonNTString Data
        .InsertNTString Username
        .SendBNCS &H3D
    End With
    
End Sub

Public Sub SendBNCS0x59()

    If Not (Email = vbNullString) Then
        AddChat vbGray, "Request has been sent to register the account under the e-mail " & Email
        With PBuffer
            .InsertNTString Email
            .SendBNCS &H59
        End With
    End If
    
End Sub


Public Sub SendBNCS0x50()

    frmMain.sckBNCS.SendData Chr(1)

        With PBuffer
          .InsertDWORD &H0
          .InsertNonNTString "68XI"
          .InsertNonNTString BNCSProductID
          .InsertDWORD VersionByte
          .InsertDWORD &H0
          .InsertDWORD &H0
          .InsertDWORD &H0
          .InsertDWORD &H0
          .InsertDWORD &H0
          .InsertNTString "USA"
          .InsertNTString "United States"
          .SendBNCS &H50
        End With

End Sub

Public Sub SendBNCS0x53(Data As String)
    AddChat vbGray, "Requesting account login proof.."

    With PBuffer
    
        .InsertNonNTString Data
        .InsertNTString Username
        .SendBNCS &H53
    
    End With

End Sub

Public Sub SendBNCS0x54(Data As String)
    AddChat vbGray, "Sending account authorization.."
    
    With PBuffer
    
        .InsertNonNTString Data
        .SendBNCS &H54
    
    End With

End Sub

Public Sub SendBNCS0x14()

    With PBuffer
    .InsertNonNTString "tenb"
    .SendBNCS &H14
    End With

End Sub

Public Sub SendBNCS0x51()

    Dim I As Integer

    With PBuffer
    
        .InsertDWORD SessionCookie
        .InsertDWORD HashVersion
        .InsertDWORD HashChecksum
        
        If ExpansionClient Then
            .InsertDWORD &H2
        Else
            .InsertDWORD &H1
        End If
        
        .InsertDWORD &H0
        
        .InsertNonNTString CDKeyData(0)
        If ExpansionClient Then .InsertNonNTString CDKeyData(1)
        
        .InsertNTString HashString
        .InsertNTString "Knight"
        
        
        .SendBNCS &H51
        
        AddChat vbGray, "Sending off client information.."
        
        If WardenEnabled = True Then
            AddChat vbGray, "Initializing Warden module.."
            Dim seed As Long
            seed = PBuffer.GetDWORD(Mid(CDKeyData(0), 17, 4))
            WardenInit 2, ClientToWardenInt, seed
            'SendBNLS0x7D_0x00
        End If
        
    End With

End Sub

Public Sub SendBNCS0x0A()

    With PBuffer
    
        If Warcraft3 Then
            .InsertBYTE &H0
        Else
            .InsertNTString Username
        End If
        
        .InsertBYTE &H0
    
        .SendBNCS &HA
    
    End With

End Sub

Public Sub SendBNCS0x0C()

    With PBuffer
    
        .InsertDWORD &H2
        .InsertNTString Channel
        .SendBNCS &HC
    
    End With
    
        ConnectedTime = DblTickCount
        QueueCount = 3000
        StartQueue 100
        
        If Warcraft3 Then RequestClanList
    
End Sub

Public Sub SendBNCS0x52(Data As String)

    With PBuffer
    
        .InsertNonNTString Data
        .InsertNTString Username
        .SendBNCS &H52
        
    End With

End Sub

Public Sub SendBNCS0x3A()

    AddChat vbGray, "Sending off account information.."
    
    With PBuffer
        
        .InsertDWORD SessionCookie
        .InsertDWORD ServerCookie
        .InsertNonNTString PasswordHash
        .InsertNTString Username
        .SendBNCS &H3A
        
    End With

End Sub

Public Sub SendBNCSMessage(Message As String)
    
    With PBuffer
    
        .InsertNTString Message
        .SendBNCS &HE
        
    End With

End Sub

Public Sub SendClanInvite(Username As String)
        
    With PBuffer
    
        .InsertDWORD GetTickCount()
        .InsertNTString Username
        .SendBNCS &H77
        
    End With

End Sub

Public Sub SendRankChange(Username As String, ByVal Rank As Integer)
        
    With PBuffer
        .InsertDWORD GetTickCount()
        .InsertNTString Username
        .InsertBYTE Rank
        .SendBNCS &H7A
    End With

End Sub
Public Sub SendMemberRemove(Username As String)
        
    With PBuffer
        .InsertDWORD GetTickCount()
        .InsertNTString Username
        .SendBNCS &H78
    End With

End Sub
Public Sub RequestClanList()

    With PBuffer
    
        .InsertDWORD GetTickCount
        .SendBNCS &H7D
        
    End With
    
End Sub
Public Sub SendMemberInfo(Username As String)
    
    With PBuffer
        .InsertDWORD GetTickCount
        .InsertDWORD ClanTag
        .InsertNTString Username
        .SendBNCS &H82
    End With
    
End Sub
