Attribute VB_Name = "modParseBNCS"
Option Explicit

Public Sub ParseBNCS(Data As String)

    Dim Buffer As New clsDebuffer
    Dim Packet As Byte
    
    Buffer.DebuffPacket (Data)
    Buffer.Advance 1

    Packet = Buffer.DebuffBYTE
    Buffer.Advance 2

    Select Case (Packet)
    
        Case &HF: Handle_0x0F Buffer
        Case &H25: Handle_0x25 Buffer
        Case &H3A: Handle_0x3A Buffer
        Case &H50: Handle_0x50 Buffer
        Case &H51: Handle_0x51 Buffer
        Case &H53: Handle_0x53 Buffer
        Case &H54: Handle_0x54 Buffer
        Case &H5E: Handle_0x5E Data
        Case &H3D: Handle_0x3D Buffer
        Case &H52: Handle_0x52 Buffer
        Case &H59: SendBNCS0x59
        Case &H75: Handle_0x75 Buffer
        Case &H77: Handle_0x77 Buffer
        Case &H78: Handle_0x78 Buffer
        Case &H7A: Handle_0x7A Buffer
        Case &H7D: Handle_0x7D Buffer
        Case &H7E: Handle_0x7E Buffer
        Case &H7F: Handle_0x7F Buffer
        Case &H82: Handle_0x82 Buffer
    End Select

End Sub

Private Sub Handle_0x7E(Buffer As clsDebuffer)

    Clan.Remove Buffer.DebuffNTString

End Sub
Private Sub Handle_0x82(Buffer As clsDebuffer)
    
        Dim status As Integer, Clan As String, Rank As String, Joined As String
        Dim LT As FILETIME, sT As SYSTEMTIME
        
        Buffer.Advance 4
        status = Buffer.DebuffBYTE
        Clan = Buffer.DebuffNTString
        
        Select Case Buffer.DebuffBYTE
            Case &H0
                Rank = "Initate"
            Case &H1
                Rank = "Peon"
            Case &H2
                Rank = "Grunt"
            Case &H3
                Rank = "Shaman"
            Case &H4
                Rank = "Chieftain"
        End Select
        
        LT.dwLowDateTime = Buffer.DebuffDWORD
        LT.dwHighDateTime = Buffer.DebuffDWORD
          
        FileTimeToLocalFileTime LT, LT
        FileTimeToSystemTime LT, sT
        
        Joined = sT.wMonth & "/" & sT.wDay & "/" & sT.wYear & " @ " & Format(sT.wHour & ":" & sT.wMinute & ":" & sT.wSecond, "HH:MM:SS ampm")
        
        If status = &H0 Then
            SendMessage ClanInvite.InvitedUser & " (" & Rank & ")" & " joined " & Clan & " on " & Joined & ".", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
        Else
            SendMessage ClanInvite.InvitedUser & " is not part of the clan.", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
        End If
End Sub
Private Sub Handle_0x7A(Buffer As clsDebuffer)

    Dim Result As Byte
        Buffer.Advance 4
        Result = Buffer.DebuffBYTE
            
            If DDPTmr = 0 Then
                Select Case Result
                    Case &H0
                        SendMessage ClanInvite.InvitedUser & "'s rank has been successfully changed!", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
                    Case &H1
                        SendMessage ClanInvite.InvitedUser & "'s rank has failed to change.", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
                    Case &H2
                        SendMessage "You cannot change that user's rank yet.", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
                    Case &H7
                        SendMessage "You are not authorized to change that user's rank yet.", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
                    Case &H8
                        SendMessage "You are not allowed to change that user's rank.", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
                End Select
            End If
End Sub
Private Sub Handle_0x7D(Buffer As clsDebuffer)
Dim I As Long, Result As Byte

    Set Clan = New clsClanList
    
    Buffer.Advance 4
    
    Result = Buffer.DebuffBYTE
    
    For I = 0 To Result - 1
        Clan.Add Buffer.DebuffNTString, Buffer.DebuffBYTE, Buffer.DebuffBYTE, Buffer.DebuffNTString
    Next I

End Sub
Private Sub Handle_0x7F(Buffer As clsDebuffer)
Dim Username As String, Rank As Integer, Location As String, status As Integer, UsrIndex As clsClan

'(STRING) Username
'(BYTE) Rank
'(BYTE) Status
'(STRING) Location
    Username = Buffer.DebuffNTString
    Rank = Buffer.DebuffBYTE
    status = Buffer.DebuffBYTE
    Location = Buffer.DebuffNTString
    
    Set UsrIndex = Clan.GetByName(Username)
    
    With UsrIndex
        .ClanRank = Rank
        .status = status
        .Location = Location
    End With
    
End Sub
Private Sub Handle_0x78(Buffer As clsDebuffer)
'0x00: Removed 0x01: Removal failed 0x02: Can not be removed yet 0x07: Not authorized to remove 0x08: Not allowed to remove
    Dim Result As Byte
        Buffer.Advance 4
        Result = Buffer.DebuffBYTE
            Select Case Result
                Case &H0
                    SendMessage ClanInvite.InvitedUser & " has been removed from the clan.", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
                    Clan.Remove ClanInvite.InvitedUser
                Case &H1
                    SendMessage ClanInvite.InvitedUser & " cannot be removed from the clan.", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
                Case &H2
                    SendMessage ClanInvite.InvitedUser & " cannot be removed from the clan yet.", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
                Case &H7
                    SendMessage "You are not authorized to remove users from the clan.", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
                Case &H8
                    SendMessage "You are not allowed to remove users from the clan.", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
            End Select
End Sub
Private Sub Handle_0x75(Buffer As clsDebuffer)
    Dim Rank As String
    Buffer.Advance 1
    ClanTag = Buffer.DebuffDWORD
    
    Select Case Buffer.DebuffBYTE
        Case &H0
            Rank = "a Initate"
        Case &H1
            Rank = "a Peon"
        Case &H2
            Rank = "a Grunt"
        Case &H3
            Rank = "a Shaman"
        Case &H4
            Rank = "the Chieftain"
    End Select
    
    Dim Result As String * 4
    CopyMemory ByVal Result, ClanTag, 4
    Result = Replace$(StrReverse$(Result), vbNullChar, vbNullString)
    
    AddChat vbGray, "You are in the Clan " & Trim$(Result) & " ranked as " & Rank & "."
End Sub
Private Sub Handle_0x77(Buffer As clsDebuffer)

    Dim Result As Byte
        Buffer.Advance 4
        Result = Buffer.DebuffBYTE
            Select Case Result
                
                Case &H0
                    SendMessage ClanInvite.InvitedUser & " has accepted the clan invitation!", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
                Case &H4
                    SendMessage ClanInvite.InvitedUser & " has declined the clan invitation.", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
                Case &H5
                    SendMessage "Failed to invite " & ClanInvite.InvitedUser & ".", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
                Case &H9
                    SendMessage "Unable to invite " & ClanInvite.InvitedUser & " as the clan is currently full.", ClanInvite.UserWhoInvited, ClanInvite.IsWhisper, ClanInvite.InBot
            End Select
        

End Sub

Private Sub Handle_0x52(Buffer As clsDebuffer)
    Dim Result As Long
        Result = Buffer.DebuffDWORD
        
        Select Case Result
            Case &H0
                AddChat vbGreen, "Account has been sucessfully created!"
                SendBNLS0x02
            Case &H4
                AddChat vbRed, Username & " already exists!"
            Case &H7
                AddChat vbRed, Username & " is too short!"
            Case &H8
                AddChat vbRed, Username & " contains an illegal character!"
            Case &H9
                AddChat vbRed, Username & " contains an illegal word!"
            Case &HA
                AddChat vbRed, Username & " contains too few alphanumeric characters!"
            Case &HB
                AddChat vbRed, Username & " contains adjacent punctuation characters!"
            Case &HC
                AddChat vbRed, Username & " contains to many punctuation characters!"
            Case Else
                AddChat vbRed, Username & " already exists!"
        End Select
            

End Sub

Private Sub Handle_0x3D(Buffer As clsDebuffer)
    Select Case Buffer.DebuffDWORD
        Case &H0
            AddChat vbGreen, Username & "  has been sucessfully created!"
            CreateAccount = False
            SendBNLS0x0B
        Case &H2
            AddChat vbRed, Username & " contains invalid characters!"
        Case &H3
            AddChat vbRed, Username & " contains a banned word!"
        Case &H4
            AddChat vbRed, Username & " already exists!"
        Case &H6
            AddChat vbRed, Username & " did not contain enough alphanumeric characters!"
            
    End Select

End Sub

Private Sub Handle_0x5E(Data As String)
    Dim PBuffer As New clsPBuffer
    Dim Result() As Byte
    Dim bArray() As Byte
    ReDim Preserve bArray(0)
    bArray = StringToByteArray(Data)
    Result = WardenOnData(2, bArray)
    If Len(ByteArrayToString(Result)) = 1 Then
        AddChat vbGreen, "Warden module is now initialized!"
    End If
    If Len(ByteArrayToString(Result)) > 0 Then
            PBuffer.InsertNonNTString ByteArrayToString(Result)
            PBuffer.SendBNCS &H5E
    End If
    'SendBNLS0x7D_0x01 Right(data, Len(data) - 4)
End Sub
Private Sub Handle_0x54(Buffer As clsDebuffer)

    Dim Result As Long, Error As String
        Result = Buffer.DebuffDWORD
        
        Select Case Result
            Case &H0
                AddChat vbCyan, "Account authorization was accepted!"
                SendBNCS0x0A
                SendBNCS0x0C
                BNCSConnected = True
            Case &H2
                AddChat vbRed, "You have entered a incorrect password!"
                Disconnected
            Case &HE
                AddChat vbRed, "You have not registered this account yet."
                SendBNCS0x59
                SendBNCS0x0A
                SendBNCS0x0C
                BNCSConnected = True
            Case &HF
                Error = Buffer.DebuffNTString
                AddChat vbRed, Error
        End Select
                
End Sub

Private Sub Handle_0x53(Buffer As clsDebuffer)
    Dim Result As Long
    
    Result = Buffer.DebuffDWORD
        Select Case Result
            Case &H0
                AddChat vbGreen, "Account logon accepted, preparing authorization.."
                SendBNLS0x03 Buffer.DebuffRaw(64)
            Case &H1
                AddChat vbRed, "Account doesn't exist.. attempting to create."
                SendBNLS0x04
            Case &HE
                AddChat vbRed, "This account requires an update."
        End Select

End Sub

Private Sub Handle_0x25(Buffer As clsDebuffer)

    With PBuffer
    
        .InsertDWORD Buffer.DebuffDWORD
        .SendBNCS &H25
    
    End With

End Sub

Private Sub Handle_0x3A(Buffer As clsDebuffer)

    Dim Result As Long
    
    Result = Buffer.DebuffDWORD
    
    Select Case Result
    
        Case &H0
            AddChat vbCyan, "Account authorization was accepted!"
            SendBNCS0x0A
            SendBNCS0x0C
            BNCSConnected = True
                            
        Case &H1
            AddChat vbRed, "This account does not exist!"
            CreateAccount = True
            SendBNLS0x0B
            
        Case &H2
            AddChat vbRed, "The password you have submitted is incorrect!"
            
        Case &H6
            AddChat vbRed, "Your account has been closed."
            
        Case Else
            AddChat vbCyan, "WTF?"
        
    End Select
    
End Sub

Private Sub Handle_0x51(Buffer As clsDebuffer)
    Dim Result As Long, MoreInfo As String
    Result = Buffer.DebuffDWORD()
    MoreInfo = Buffer.DebuffNTString()
    
    Select Case Result
    Case &H0
        AddChat vbGreen, "Client data is accepted, proceeding.."
        If Warcraft3 Then
            SendBNLS0x02
        Else
            SendBNCS0x14
            SendBNLS0x0B
        End If
    
    Case &H100
       
            AddChat vbRed, "Client version is too old (" & MoreInfo & ")!"
            AddChat vbRed, "The BNLS server you are using is outdated."
    
    Case &H101
            AddChat vbRed, "Client version is invalid!"
            AddChat vbRed, "The BNLS server you are using is outdated or problematic."
    Case &H102
 
            AddChat vbRed, "Client version is too new (" & MoreInfo & ")!"
            AddChat vbRed, "The BNLS server you are using has hashes that are newer than the server you are connecting to."

    Case &H200: AddChat vbRed, "Your cdkey is invalid."
    Case &H201: AddChat vbRed, "Your cdkey is being used by " & IIf(LenB(MoreInfo) > 0, MoreInfo & "!", "an unidentified user!")
    Case &H202: AddChat vbRed, "Your cdkey is banned from this server!"
    Case &H203: AddChat vbRed, "Your cdkey is for another client!"
    Case &H210: AddChat vbRed, "Your expansion cdkey is invalid!"
    Case &H211: AddChat vbRed, "Your expansion cdkey is being used by " & IIf(LenB(MoreInfo) > 0, MoreInfo & "!", "an unidentified user!")
    Case &H212: AddChat vbRed, "Your expansion cdkey is banned from this server!"
    Case &H213: AddChat vbRed, "Your expansion cdkey is for another client!"
    
    End Select
End Sub

Private Sub Handle_0x50(Buffer As clsDebuffer)

            LogonType = Buffer.DebuffDWORD
            ServerCookie = Buffer.DebuffDWORD
            UDPValue = Buffer.DebuffDWORD
            FileTimeLOW = Buffer.DebuffDWORD
            FileTimeHIGH = Buffer.DebuffDWORD
            MPQString = Buffer.DebuffNTString
            ValueString = Buffer.DebuffNTString
            
            SendBNLS0x0D
            SendBNLS0x0C
            
End Sub
Private Sub Handle_0x0F(Buffer As clsDebuffer)

    Dim EventID As Long, Username As String, Ping As Long, Flags As Long, Text As String
    EventID = Buffer.DebuffDWORD
    Flags = Buffer.DebuffDWORD
    Ping = Buffer.DebuffDWORD
    Buffer.Advance 12
    Username = Suffix(Buffer.DebuffNTString)
    Text = Buffer.DebuffNTString

    Select Case EventID
    
        Case EID_CHANNEL
            Call Event_Channel(Text, Flags)
        Case EID_TALK
            Call Event_Talk(Username, Text, Ping)
        Case EID_SHOWUSER
            Call Event_ShowUsers(Username, Ping, Flags, Text)
        Case EID_USERFLAGS
            Call Event_UserFlags(Username, Ping, Flags)
        Case EID_JOIN
            Call Event_Join(Username, Ping, Flags, Text)
        Case EID_LEAVE
            Call Event_Leave(Username)
        Case EID_INFO
            Call Event_Info(Text)
        Case EID_WHISPER
            Call Event_Whisper(Username, Text)
        Case EID_WHISPERSENT
            Call Event_WhisperSent(Username, Text)
        Case EID_EMOTE
            Call Event_Emote(Username, Text)
        Case EID_ERROR
            Call Event_Error(Text)
        Case EID_BROADCAST
            Call Event_Broadcast(Text)
    End Select

End Sub
